> This page is for 平台, version V4 实验版.
> For other versions, use one of these documentation indexes:
> - V4 (default): https://next.developer.frame.io/platform/v4/llms.txt
> - V4 实验版: https://next.developer.frame.io/platform/v4-experimental/llms.txt
> - 旧版: https://next.developer.frame.io/platform/v2/llms.txt

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://next.developer.frame.io/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://next.developer.frame.io/_mcp/server.

# 列出评论

GET https://api.frame.io/v4/accounts/{account_id}/files/{file_id}/comments

List comments on a given asset.
This endpoint has been added to `Current Version` of the API.
Please see [https://developer.adobe.com/frameio/api/current/#tag/Comments/operation/comments.index](https://developer.adobe.com/frameio/api/current/#tag/Comments/operation/comments.index).
Rate Limits: 100 calls per 1.00 minute(s) per account\_user

Reference: https://next.developer.frame.io/platform/api-reference/comments/index

## Authentication

- `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer <token>`, where token is your auth token.

## Request

### Path parameters

- `account_id` (string, required)
- `file_id` (string, required)

### Query parameters

- `timestamp_as_timecode` (boolean, optional)
- `include` (enum, optional)
  - Allowed values: `owner`, `replies`
- `sort` (enum, optional) — Sort comments by query params
  - Allowed values: `owner_asc`, `owner_desc`, `completed_at_asc`, `completed_at_desc`, `created_at_asc`, `created_at_desc`
- `after` (string, optional) — Opaque Cursor query param for requests returning paginated results. NOTE: this value is auto-generated and included as part of links from a previous response. It is not intended to be human readable.
- `page_size` (integer, optional, default: 50)
- `include_total_count` (boolean, optional, default: false)

## Response

### 200

OK

- `data` (list of CommentWithIncludes, required) — Comments
- `links` (Links, required) — Links to paginated data
- `total_count` (integer, optional, nullable) — Total count

## Errors

### 400 Bad Request Error

Bad request

- `errors` (list of BadRequestErrorsItems, required)

### 401 Unauthorized Error

Unauthorized

- `errors` (list of UnauthorizedErrorsItems, required)

### 403 Forbidden Error

Forbidden

- `errors` (list of ForbiddenErrorsItems, required)

### 404 Not Found Error

Not found

- `errors` (list of NotFoundErrorsItems, required)

### 409 Conflict Error

Conflict

- `errors` (list of ConflictErrorsItems, required)

### 422 Unprocessable Entity Error

Unprocessable content

- `errors` (list of UnprocessableContentErrorsItems, required)

### 429 Too Many Requests Error

Too many requests

- `errors` (list of TooManyRequestsErrorsItems, required)

## Types

### CommentWithIncludes

- `annotation` (string, required, nullable)
- `attachments` (list of CommentAttachment, required, nullable) — Attachments associated with this comment (0-6 attachments allowed)
- `completed_at` (string, required, nullable) — Completion timestamp
- `completer_id` (string, required, nullable) — ID of user who marked the comment as completed
- `created_at` (string, required) — Creation timestamp
- `duration` (integer, required, nullable) — Duration of comment in frames. Requires presence of timestamp parameter
- `file_id` (string, required) — File ID
- `id` (string, required) — Comment ID
- `links` (list of Link, required) — Links
- `mentions` (list of Mention, required) — Mentions
- `page` (integer, required, nullable) — Document page
- `text` (string, required) — Comment text
- `text_edited_at` (string, required, nullable) — Text edited timestamp
- `text_review_annotation` (TextReviewAnnotation, required, nullable) — Text review annotation details for comments left on text documents.
- `timestamp` (TimeStamp, required)
- `updated_at` (string, required) — Update timestamp
- `anchor` (Anchor, optional, nullable) — Comment anchor location. \{(x, y) | 0 \<= x \<= 1, 0 \<= y \<= 1}.
- `owner` (User, optional) — User details
- `replies` (list of Comment, optional) — Replies

### Links

Links to paginated data

- `next` (string, required, nullable) — "Link to next page of data. This link is the request path with the addition of the `after` query parameter to fetch the next page of results. It only carries the `after` cursor. Other query params from the original request (e.g. `include`, `sort`, `page_size`, `include_total_count`, filters) are not preserved and must be re-added by the client on every subsequent request, including when following this link.

### BadRequestErrorsItems

- `detail` (string, required)
- `source` (BadRequestErrorsItemsSource, optional)
- `title` (string, optional)

### UnauthorizedErrorsItems

- `detail` (string, required)
- `source` (UnauthorizedErrorsItemsSource, optional)
- `title` (string, optional)

### ForbiddenErrorsItems

- `detail` (string, required)
- `source` (ForbiddenErrorsItemsSource, optional)
- `title` (string, optional)

### NotFoundErrorsItems

- `detail` (string, required)
- `source` (NotFoundErrorsItemsSource, optional)
- `title` (string, optional)

### ConflictErrorsItems

- `detail` (string, required)
- `source` (ConflictErrorsItemsSource, optional)
- `title` (string, optional)

### UnprocessableContentErrorsItems

- `detail` (string, required)
- `source` (UnprocessableContentErrorsItemsSource, optional)
- `title` (string, optional)

### TooManyRequestsErrorsItems

- `detail` (string, required)
- `source` (TooManyRequestsErrorsItemsSource, optional)
- `title` (string, optional)

### CommentAttachment

- `created_at` (string, required) — Creation timestamp
- `file_size` (integer, required) — Attachment file size in bytes (up to 5TB)
- `id` (string, required) — Comment attachment ID
- `media_type` (string, required, nullable) — File media type
- `name` (string, required) — File name for the attachment
- `upload_urls` (list of string, optional, nullable) — Comment attachment upload URLs. Number of URLs returned will vary depending on the file size.

### Link

- `end_index` (integer, required) — End index of link text
- `start_index` (integer, required) — Start index of link text
- `text` (string, required) — Link text
- `url` (string, required) — Link URL

### Mention

- `end_index` (integer, required) — End index of mention text
- `start_index` (integer, required) — Start index of mention text
- `text` (string, required) — Mention text
- `user_id` (string, required) — Mentioned user ID

### TextReviewAnnotation

- `bounds` (list of TextReviewAnnotationBounds, required) — An array of bounds representing a multiline selection origin at the lower-left corner.
- `selection_text` (string, required, nullable) — Selected text from the document.
- `suggested_text` (string, required, nullable) — Suggested replacement or insertion text.
- `text_review_annotation_type` (enum, required) — The type of text review annotation.
  - Allowed values: `highlight`, `insert`, `remove`, `replace`

### TimeStamp

### Anchor

- `x` (float, required) — Horizontal comment anchor location.
- `y` (float, required) — Vertical comment anchor location.

### User

User details

- `active` (boolean, required, nullable) — User active status
- `avatar_url` (string, required, nullable) — User avatar image url
- `email` (string, required) — User email
- `id` (string, required, nullable) — User ID - can be null for invited users with no Frame account
- `name` (string, required, nullable) — User name
- `adobe_user_id` (string, optional, nullable) — Adobe user ID

### Comment

- `annotation` (string, required, nullable)
- `attachments` (list of CommentAttachment, required, nullable) — Attachments associated with this comment (0-6 attachments allowed)
- `completed_at` (string, required, nullable) — Completion timestamp
- `completer_id` (string, required, nullable) — ID of user who marked the comment as completed
- `created_at` (string, required) — Creation timestamp
- `duration` (integer, required, nullable) — Duration of comment in frames. Requires presence of timestamp parameter
- `file_id` (string, required) — File ID
- `id` (string, required) — Comment ID
- `links` (list of Link, required) — Links
- `mentions` (list of Mention, required) — Mentions
- `page` (integer, required, nullable) — Document page
- `text` (string, required) — Comment text
- `text_edited_at` (string, required, nullable) — Text edited timestamp
- `text_review_annotation` (TextReviewAnnotation, required, nullable) — Text review annotation details for comments left on text documents.
- `timestamp` (TimeStamp, required)
- `updated_at` (string, required) — Update timestamp
- `anchor` (Anchor, optional, nullable) — Comment anchor location. \{(x, y) | 0 \<= x \<= 1, 0 \<= y \<= 1}.

### BadRequestErrorsItemsSource

- `pointer` (string, optional)

### UnauthorizedErrorsItemsSource

- `pointer` (string, optional)

### ForbiddenErrorsItemsSource

- `pointer` (string, optional)

### NotFoundErrorsItemsSource

- `pointer` (string, optional)

### ConflictErrorsItemsSource

- `pointer` (string, optional)

### UnprocessableContentErrorsItemsSource

- `pointer` (string, optional)

### TooManyRequestsErrorsItemsSource

- `pointer` (string, optional)

### TextReviewAnnotationBounds

- `height` (double, required) — Height of the rectangle
- `width` (double, required) — Width of the rectangle
- `x` (double, required) — Left corner position.
- `y` (double, required) — Bottom corner position.

## Examples

**Response**

```json
{
  "data": [
    {
      "annotation": "annotation",
      "attachments": [
        {
          "created_at": "2024-02-02T21:19:24.828948Z",
          "file_size": 1024000,
          "id": "0d9398aa-62c5-4c55-90d8-b00bda4ec283",
          "media_type": "image/png",
          "name": "screenshot.png",
          "upload_urls": [
            "https://s3.amazonaws.com/bucket/part1?signature=..."
          ]
        }
      ],
      "completed_at": null,
      "completer_id": null,
      "created_at": "2024-02-02T21:19:24.828948Z",
      "duration": 10,
      "file_id": "4ae08df1-b419-4897-aba5-560198a18237",
      "id": "a767587c-f8b3-4220-974f-b5a498606d24",
      "links": [
        {
          "end_index": 13,
          "start_index": 5,
          "text": "Test User",
          "url": "https://www.example.com"
        }
      ],
      "mentions": [
        {
          "end_index": 13,
          "start_index": 5,
          "text": "Test User",
          "user_id": "aaae24d8-7590-4af7-9f4e-821c07b099b0"
        }
      ],
      "page": 1,
      "text": "This is great!",
      "text_edited_at": "2024-02-02T21:19:24.828948Z",
      "text_review_annotation": {
        "bounds": [
          {
            "height": 42,
            "width": 130,
            "x": 12.5,
            "y": 24
          }
        ],
        "selection_text": "existing copy",
        "suggested_text": "updated copy",
        "text_review_annotation_type": "replace"
      },
      "timestamp": 123,
      "updated_at": "2024-02-02T21:19:24.828948Z",
      "anchor": {
        "x": 0.5,
        "y": 0.5
      },
      "owner": {
        "active": true,
        "avatar_url": "https://assets.frame.io/uploads/cd58cb8e-24b3-4448-8d0f-9532fcd04d11/original.png?response-content-disposition=attachment%3B+filename%3D%22foo.png&Expires=1729857600&Signature=L09h0pi82dCrMYjr9lMHBragByWYh1&Key-Pair-Id=KKI497NESTHMN",
        "email": "user_email@example.com",
        "id": "7cf3b0de-bf3e-41ab-9a14-67ed4cc226a9",
        "name": "Jon Doe",
        "adobe_user_id": "196C1A5666BF4EB00A49411B@176719f5667c82b4494214.e"
      },
      "replies": []
    },
    {
      "annotation": "annotation",
      "attachments": [
        {
          "created_at": "2024-02-02T21:19:24.828948Z",
          "file_size": 1024000,
          "id": "0d9398aa-62c5-4c55-90d8-b00bda4ec283",
          "media_type": "image/png",
          "name": "screenshot.png",
          "upload_urls": [
            "https://s3.amazonaws.com/bucket/part1?signature=..."
          ]
        }
      ],
      "completed_at": null,
      "completer_id": null,
      "created_at": "2024-02-02T21:19:24.828948Z",
      "duration": 10,
      "file_id": "4ae08df1-b419-4897-aba5-560198a18237",
      "id": "a767587c-f8b3-4220-974f-b5a498606d24",
      "links": [
        {
          "end_index": 13,
          "start_index": 5,
          "text": "Test User",
          "url": "https://www.example.com"
        }
      ],
      "mentions": [
        {
          "end_index": 13,
          "start_index": 5,
          "text": "Test User",
          "user_id": "aaae24d8-7590-4af7-9f4e-821c07b099b0"
        }
      ],
      "page": 1,
      "text": "This is great!",
      "text_edited_at": "2024-02-02T21:19:24.828948Z",
      "text_review_annotation": {
        "bounds": [
          {
            "height": 42,
            "width": 130,
            "x": 12.5,
            "y": 24
          }
        ],
        "selection_text": "existing copy",
        "suggested_text": "updated copy",
        "text_review_annotation_type": "replace"
      },
      "timestamp": 123,
      "updated_at": "2024-02-02T21:19:24.828948Z",
      "anchor": {
        "x": 0.5,
        "y": 0.5
      },
      "owner": {
        "active": true,
        "avatar_url": "https://assets.frame.io/uploads/cd58cb8e-24b3-4448-8d0f-9532fcd04d11/original.png?response-content-disposition=attachment%3B+filename%3D%22foo.png&Expires=1729857600&Signature=L09h0pi82dCrMYjr9lMHBragByWYh1&Key-Pair-Id=KKI497NESTHMN",
        "email": "user_email@example.com",
        "id": "7cf3b0de-bf3e-41ab-9a14-67ed4cc226a9",
        "name": "Jon Doe",
        "adobe_user_id": "196C1A5666BF4EB00A49411B@176719f5667c82b4494214.e"
      },
      "replies": [
        {
          "annotation": "annotation",
          "attachments": [
            {
              "created_at": "2024-02-02T21:19:24.828948Z",
              "file_size": 1024000,
              "id": "0d9398aa-62c5-4c55-90d8-b00bda4ec283",
              "media_type": "image/png",
              "name": "screenshot.png",
              "upload_urls": [
                "https://s3.amazonaws.com/bucket/part1?signature=..."
              ]
            }
          ],
          "completed_at": null,
          "completer_id": null,
          "created_at": "2024-02-02T21:19:24.828948Z",
          "duration": 10,
          "file_id": "4ae08df1-b419-4897-aba5-560198a18237",
          "id": "a767587c-f8b3-4220-974f-b5a498606d24",
          "links": [
            {
              "end_index": 13,
              "start_index": 5,
              "text": "Test User",
              "url": "https://www.example.com"
            }
          ],
          "mentions": [
            {
              "end_index": 13,
              "start_index": 5,
              "text": "Test User",
              "user_id": "aaae24d8-7590-4af7-9f4e-821c07b099b0"
            }
          ],
          "page": 1,
          "text": "This is great!",
          "text_edited_at": "2024-02-02T21:19:24.828948Z",
          "text_review_annotation": {
            "bounds": [
              {
                "height": 42,
                "width": 130,
                "x": 12.5,
                "y": 24
              }
            ],
            "selection_text": "existing copy",
            "suggested_text": "updated copy",
            "text_review_annotation_type": "replace"
          },
          "timestamp": 123,
          "updated_at": "2024-02-02T21:19:24.828948Z",
          "anchor": {
            "x": 0.5,
            "y": 0.5
          }
        }
      ]
    }
  ],
  "links": {
    "next": "/v4/accounts/123/files/123/comments"
  },
  "total_count": 10
}
```

**SDK Code**

```python
import requests

url = "https://api.frame.io/v4/accounts/95f15c38-68b4-4dd6-8936-6d6297cd966b/files/5252b69a-36c1-4cfd-b7b7-1f058ffbacc8/comments"

headers = {"Authorization": "Bearer <token>"}

response = requests.get(url, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.frame.io/v4/accounts/95f15c38-68b4-4dd6-8936-6d6297cd966b/files/5252b69a-36c1-4cfd-b7b7-1f058ffbacc8/comments';
const options = {method: 'GET', headers: {Authorization: 'Bearer <token>'}};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://api.frame.io/v4/accounts/95f15c38-68b4-4dd6-8936-6d6297cd966b/files/5252b69a-36c1-4cfd-b7b7-1f058ffbacc8/comments"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("Authorization", "Bearer <token>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.frame.io/v4/accounts/95f15c38-68b4-4dd6-8936-6d6297cd966b/files/5252b69a-36c1-4cfd-b7b7-1f058ffbacc8/comments")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = 'Bearer <token>'

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://api.frame.io/v4/accounts/95f15c38-68b4-4dd6-8936-6d6297cd966b/files/5252b69a-36c1-4cfd-b7b7-1f058ffbacc8/comments")
  .header("Authorization", "Bearer <token>")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://api.frame.io/v4/accounts/95f15c38-68b4-4dd6-8936-6d6297cd966b/files/5252b69a-36c1-4cfd-b7b7-1f058ffbacc8/comments', [
  'headers' => [
    'Authorization' => 'Bearer <token>',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.frame.io/v4/accounts/95f15c38-68b4-4dd6-8936-6d6297cd966b/files/5252b69a-36c1-4cfd-b7b7-1f058ffbacc8/comments");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "Bearer <token>");
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = ["Authorization": "Bearer <token>"]

let request = NSMutableURLRequest(url: NSURL(string: "https://api.frame.io/v4/accounts/95f15c38-68b4-4dd6-8936-6d6297cd966b/files/5252b69a-36c1-4cfd-b7b7-1f058ffbacc8/comments")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```